#if !defined(ISSAFE_H)
#define ISSAFE_H

#include "isshrt.h"

#if (!defined(HAVE_LONG_LONG_INT)) && ((__STDC_VERSION__ + 0) >= 199901)
#define HAVE_LONG_LONG_INT		1
#endif

#if defined(__cplusplus)
extern "C" {
#endif

extern int (is_abs_safe)	(int a);
extern int (is_add_safe)	(int a, int b);
extern int (is_div_safe)	(int a, int b);
extern int (is_mul_safe)	(int a, int b);
extern int (is_neg_safe)	(int a);
extern int (is_rem_safe)	(int a, int b);
extern int (is_sub_safe)	(int a, int b);

extern int (is_abs_safel)	(long a);
extern int (is_add_safel)	(long a, long b);
extern int (is_div_safel)	(long a, long b);
extern int (is_mul_safel)	(long a, long b);
extern int (is_neg_safel)	(long a);
extern int (is_rem_safel)	(long a, long b);
extern int (is_sub_safel)	(long a, long b);

#if defined(HAVE_LONG_LONG_INT)
extern int (is_abs_safell)	(long long a);
extern int (is_add_safell)	(long long a, long long b);
extern int (is_div_safell)	(long long a, long long b);
extern int (is_mul_safell)	(long long a, long long b);
extern int (is_neg_safell)	(long long a);
extern int (is_rem_safell)	(long long a, long long b);
extern int (is_sub_safell)	(long long a, long long b);
#endif

#if defined(__cplusplus)
}
#endif

#endif /* !defined(ISSAFE_H) */
